//user:    GSC
//date:    25/01/2024
//ver:     4.6.0
//project: TEST 4.6.0
//type:    event trigger (TRIGGER DI CLASSE)
//class:   gwa_func
//note:    gwa_func event trigger

import org.springframework.core.env.Environment;
import com.geowebframework.transfer.objects.exception.*;
	

public class GwaFuncEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	private final String CLASS_NAME = "gwa_func";
	private final String CLASS_TABLE_NAME = CLASS_NAME;
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeInsert()");
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterInsert()");
		
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeUpdate()");
		
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterUpdate()");
		
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeDelete()");
		
		def id_func = valuesMap.id_func;
		String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE id_func="+id_func+"";
		def res = services.queryService.executeQuery(query, null)[0];
		if(res!=null) valuesMap.cod_func = res.cod_func;
		
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterDelete()");
		
		String query = "DELETE FROM gwr_r_rep_cat_func WHERE cod_func='"+valuesMap.cod_func+"'";
		def res = services.queryService.executeDeleteQuery(query, null);
		
		return true;
	};

} 