//user:    GSC
//date:    06/06/2024
//ver:     4.7.0
//project: test_47
//type:    event trigger (TRIGGER DI CLASSE)
//class:   gwr_r_rep_cat_func
//note:    gwr_r_rep_cat_func event trigger

import org.springframework.core.env.Environment;
import com.geowebframework.transfer.objects.exception.*;
	

public class GwrRRepCatFuncEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	private final String CLASS_NAME = "gwr_r_rep_cat_func";
	private final String CLASS_TABLE_NAME = CLASS_NAME;
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - beforeInsert()");
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - afterInsert()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - beforeUpdate()");
		
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - afterUpdate()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - beforeDelete()");
		
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_rep_cat_func - afterDelete()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};

} 